Unverified Commit dec2dc92 authored by Kroese's avatar Kroese Committed by GitHub
Browse files

feat: Check free diskspace during startup (#1080)

parent 2c44669d
Loading
Loading
Loading
Loading
+100 −58
Original line number Diff line number Diff line
@@ -18,7 +18,7 @@ SYSTEM="$STORAGE/$BASE.system.img"
[ ! -s "$SYSTEM" ] && error "Virtual DSM system-image does not exist ($SYSTEM)" && exit 82

fmt2ext() {
  local DISK_FMT=$1
  local DISK_FMT="$1"

  case "${DISK_FMT,,}" in
    qcow2)
@@ -34,7 +34,7 @@ fmt2ext() {
}

ext2fmt() {
  local DISK_EXT=$1
  local DISK_EXT="$1"

  case "${DISK_EXT,,}" in
    qcow2)
@@ -50,7 +50,7 @@ ext2fmt() {
}

getSize() {
  local DISK_FILE=$1
  local DISK_FILE="$1"
  local DISK_EXT DISK_FMT

  DISK_EXT=$(echo "${DISK_FILE//*./}" | sed 's/^.*\.//')
@@ -70,7 +70,7 @@ getSize() {
}

isCow() {
  local FS=$1
  local FS="$1"

  if [[ "${FS,,}" == "btrfs" ]]; then
    return 0
@@ -80,7 +80,7 @@ isCow() {
}

supportsDirect() {
  local FS=$1
  local FS="$1"

  if [[ "${FS,,}" == "ecryptfs" || "${FS,,}" == "tmpfs" ]]; then
    return 1
@@ -91,11 +91,11 @@ supportsDirect() {

createDisk() {

  local DISK_FILE=$1
  local DISK_SPACE=$2
  local DISK_DESC=$3
  local DISK_FMT=$4
  local FS=$5
  local DISK_FILE="$1"
  local DISK_SPACE="$2"
  local DISK_DESC="$3"
  local DISK_FMT="$4"
  local FS="$5"
  local DATA_SIZE DIR SPACE GB FA

  rm -f "$DISK_FILE"
@@ -113,6 +113,7 @@ createDisk() {
      error "Not enough free space to create a $DISK_DESC of ${DISK_SPACE/G/ GB} in $DIR, it has only $GB available..."
      error "Please specify a smaller ${DISK_DESC^^}_SIZE or disable preallocation by setting ALLOCATE=N." && exit 76
    fi

  fi

  html "Creating a $DISK_DESC image..."
@@ -177,11 +178,11 @@ createDisk() {

resizeDisk() {

  local DISK_FILE=$1
  local DISK_SPACE=$2
  local DISK_DESC=$3
  local DISK_FMT=$4
  local FS=$5
  local DISK_FILE="$1"
  local DISK_SPACE="$2"
  local DISK_DESC="$3"
  local DISK_FMT="$4"
  local FS="$5"
  local CUR_SIZE DATA_SIZE DIR SPACE GB

  CUR_SIZE=$(getSize "$DISK_FILE")
@@ -200,6 +201,7 @@ resizeDisk() {
      error "Not enough free space to resize $DISK_DESC to ${DISK_SPACE/G/ GB} in $DIR, it has only $GB available.."
      error "Please specify a smaller ${DISK_DESC^^}_SIZE or disable preallocation by setting ALLOCATE=N." && exit 74
    fi

  fi

  GB=$(formatBytes "$CUR_SIZE")
@@ -245,13 +247,13 @@ resizeDisk() {

convertDisk() {

  local SOURCE_FILE=$1
  local SOURCE_FMT=$2
  local DST_FILE=$3
  local DST_FMT=$4
  local DISK_BASE=$5
  local DISK_DESC=$6
  local FS=$7
  local SOURCE_FILE="$1"
  local SOURCE_FMT="$2"
  local DST_FILE="$3"
  local DST_FMT="$4"
  local DISK_BASE="$5"
  local DISK_DESC="$6"
  local FS="$7"

  [ -f "$DST_FILE" ] && error "Conversion failed, destination file $DST_FILE already exists?" && exit 79
  [ ! -f "$SOURCE_FILE" ] && error "Conversion failed, source file $SOURCE_FILE does not exists?" && exit 79
@@ -273,6 +275,7 @@ convertDisk() {
      error "Not enough free space to convert $DISK_DESC to $DST_FMT in $DIR, it has only $GB available..."
      error "Please free up some disk space or disable preallocation by setting ALLOCATE=N." && exit 76
    fi

  fi

  local msg="Converting $DISK_DESC to $DST_FMT"
@@ -327,9 +330,9 @@ convertDisk() {

checkFS () {

  local FS=$1
  local DISK_FILE=$2
  local DISK_DESC=$3
  local FS="$1"
  local DISK_FILE="$2"
  local DISK_DESC="$3"
  local DIR FA

  DIR=$(dirname "$DISK_FILE")
@@ -361,15 +364,15 @@ checkFS () {

createDevice () {

  local DISK_FILE=$1
  local DISK_TYPE=$2
  local DISK_INDEX=$3
  local DISK_ADDRESS=$4
  local DISK_FMT=$5
  local DISK_IO=$6
  local DISK_CACHE=$7
  local DISK_SERIAL=$8
  local DISK_SECTORS=$9
  local DISK_FILE="$1"
  local DISK_TYPE="$2"
  local DISK_INDEX="$3"
  local DISK_ADDRESS="$4"
  local DISK_FMT="$5"
  local DISK_IO="$6"
  local DISK_CACHE="$7"
  local DISK_SERIAL="$8"
  local DISK_SECTORS="$9"
  local DISK_ID="data$DISK_INDEX"

  local index=""
@@ -415,16 +418,16 @@ createDevice () {

addDisk () {

  local DISK_BASE=$1
  local DISK_TYPE=$2
  local DISK_DESC=$3
  local DISK_SPACE=$4
  local DISK_INDEX=$5
  local DISK_ADDRESS=$6
  local DISK_FMT=$7
  local DISK_IO=$8
  local DISK_CACHE=$9
  local DISK_EXT DIR SPACE GB DATA_SIZE FS PREV_FMT PREV_EXT CUR_SIZE
  local DISK_BASE="$1"
  local DISK_TYPE="$2"
  local DISK_DESC="$3"
  local DISK_SPACE="$4"
  local DISK_INDEX="$5"
  local DISK_ADDRESS="$6"
  local DISK_FMT="$7"
  local DISK_IO="$8"
  local DISK_CACHE="$9"
  local DISK_EXT DIR SPACE GB DATA_SIZE FS PREV_FMT PREV_EXT CUR_SIZE LEFT FREE USED

  DISK_EXT=$(fmt2ext "$DISK_FMT")
  local DISK_FILE="$DISK_BASE.$DISK_EXT"
@@ -435,22 +438,22 @@ addDisk () {
  if [[ "${DISK_SPACE,,}" == "max" || "${DISK_SPACE,,}" == "half" ]]; then

    local SPARE=2147483648
    SPACE=$(df --output=avail -B 1 "$DIR" | tail -n 1)
    FREE=$(df --output=avail -B 1 "$DIR" | tail -n 1)

    if [[ "${DISK_SPACE,,}" == "max" ]]; then
      SPACE=$((SPACE-SPARE))
      FREE=$(( FREE - SPARE ))
    else
      SPACE=$(( SPACE / 2 ))
      FREE=$(( FREE / 2 ))
    fi

    (( SPACE < SPARE )) && SPACE="$SPARE" 
    GB=$(( SPACE/1073741825 ))
    (( FREE < SPARE )) && FREE="$SPARE"
    GB=$(( FREE / 1073741825 ))
    DISK_SPACE="${GB}G"

  fi

  SPACE="${DISK_SPACE// /}"
  [ -z "$SPACE" ] && SPACE="16G"
  [ -z "$SPACE" ] && SPACE="256G"
  [ -z "${SPACE//[0-9. ]}" ] && SPACE="${SPACE}G"
  SPACE=$(echo "${SPACE^^}" | sed 's/MB/M/g;s/GB/G/g;s/TB/T/g')

@@ -461,7 +464,7 @@ addDisk () {
  DATA_SIZE=$(numfmt --from=iec "$SPACE")

  if (( DATA_SIZE < 6442450944 )); then
    error "Please increase ${DISK_DESC^^}_SIZE to at least 6 GB." && exit 73
    error "Please increase the ${DISK_DESC^^}_SIZE variable to at least 6 GB." && exit 73
  fi

  FS=$(stat -f -c %T "$DIR")
@@ -472,7 +475,7 @@ addDisk () {
    DISK_CACHE="writeback"
  fi

  if ! [ -s "$DISK_FILE" ] ; then
  if [ ! -s "$DISK_FILE" ] ; then

    if [[ "${DISK_FMT,,}" != "raw" ]]; then
      PREV_FMT="raw"
@@ -485,6 +488,7 @@ addDisk () {
    if [ -s "$DISK_BASE.$PREV_EXT" ] ; then
      convertDisk "$DISK_BASE.$PREV_EXT" "$PREV_FMT" "$DISK_FILE" "$DISK_FMT" "$DISK_BASE" "$DISK_DESC" "$FS" || exit $?
    fi

  fi

  if [ -s "$DISK_FILE" ]; then
@@ -492,7 +496,18 @@ addDisk () {
    CUR_SIZE=$(getSize "$DISK_FILE")

    if (( DATA_SIZE > CUR_SIZE )); then

      resizeDisk "$DISK_FILE" "$SPACE" "$DISK_DESC" "$DISK_FMT" "$FS" || exit $?

    else

      if (( DATA_SIZE < CUR_SIZE )); then

        if [[ "${DISK_SPACE,,}" != "max" && "${DISK_SPACE,,}" != "half" ]]; then
          info "You decreased the ${DISK_DESC^^}_SIZE variable to ${DISK_SPACE/G/ GB} but shrinking disks is not supported, will be ignored..."
        fi

      fi
    fi

  else
@@ -501,6 +516,33 @@ addDisk () {

  fi

  if [ -f "$DISK_FILE" ] && [[ "$ALLOCATE" == [Nn]* ]]; then

    CUR_SIZE=$(getSize "$DISK_FILE")
    USED=$(du -sB 1 "$DISK_FILE" | cut -f1)
    FREE=$(df --output=avail -B 1 "$DIR" | tail -n 1)
    LEFT=$(( CUR_SIZE - USED - FREE ))

    if (( LEFT > 0 )); then

      GB=$(formatBytes "$FREE")
      LEFT=$(formatBytes "$LEFT")
      CUR_SIZE=$(formatBytes "$CUR_SIZE")
      msg="the virtual size of the ${DISK_DESC,,} is $CUR_SIZE"

      if [[ "$USED" == "0" ]]; then
        msg+=","
      else
        USED=$(formatBytes "$USED")
        msg+=" (of which $USED is used),"
      fi

      warn "$msg but there is only $GB of free space left in $DIR, make at least $LEFT more room available!"

    fi

  fi

  DISK_OPTS+=$(createDevice "$DISK_FILE" "$DISK_TYPE" "$DISK_INDEX" "$DISK_ADDRESS" "$DISK_FMT" "$DISK_IO" "$DISK_CACHE" "" "")

  return 0
@@ -508,10 +550,10 @@ addDisk () {

addDevice () {

  local DISK_DEV=$1
  local DISK_TYPE=$2
  local DISK_INDEX=$3
  local DISK_ADDRESS=$4
  local DISK_DEV="$1"
  local DISK_TYPE="$2"
  local DISK_INDEX="$3"
  local DISK_ADDRESS="$4"

  [ -z "$DISK_DEV" ] && return 0
  [ ! -b "$DISK_DEV" ] && error "Device $DISK_DEV cannot be found! Please add it to the 'devices' section of your compose file." && exit 55